#pragma once

#include "pas2c.h"

#include "uConsts.h"
static const string255 LuaLibName = STRINIT("liblua");
typedef size_t * Psize_t;
typedef pointer * PPointer;
typedef struct __lua_State {
        } lua_State;
typedef struct __lua_State * Plua_State;
typedef double LUA_NUMBER_;
typedef PtrInt LUA_INTEGER_;
enum{LUA_IDSIZE = 60};
enum{LUAL_BUFFERSIZE = 1024};
static const string255 LUA_PROMPT = STRINIT("> ");
static const string255 LUA_PROMPT2 = STRINIT(">> ");
void luapas_lua_saveline(Plua_State L,LongInt idx);
void luapas_lua_freeline(Plua_State L,PChar b);
static const bool lua_stdin_is_tty = true;
static const string255 LUA_VERSION = STRINIT("Lua 5.1");
enum{LUA_VERSION_NUM = 501};
static const string255 LUA_COPYRIGHT = STRINIT("Copyright (C) 1994-2006 Tecgraf, PUC-Rio");
static const string255 LUA_AUTHORS = STRINIT("R. Ierusalimschy, L. H. de Figueiredo & W. Celes");
enum{LUA_MULTRET = -1};
enum{LUA_REGISTRYINDEX = -10000};
enum{LUA_ENVIRONINDEX = -10001};
enum{LUA_GLOBALSINDEX = -10002};
LongInt luapas_lua_upvalueindex(LongInt idx);
enum{LUA_YIELD_ = 1};
enum{LUA_ERRRUN = 2};
enum{LUA_ERRSYNTAX = 3};
enum{LUA_ERRMEM = 4};
enum{LUA_ERRERR = 5};
typedef LongInt(*luapas_lua_CFunction)(Plua_State L);
typedef PChar(*luapas_lua_Reader)(Plua_State L,pointer ud,Psize_t sz);
typedef LongInt(*luapas_lua_Writer)(Plua_State L,pointer p,size_t sz,pointer ud);
typedef pointer(*luapas_lua_Alloc)(pointer ud,pointer ptr,size_t osize,size_t nsize);
enum{LUA_TNONE = -1};
enum{LUA_TNIL = 0};
enum{LUA_TBOOLEAN = 1};
enum{LUA_TLIGHTUSERDATA = 2};
enum{LUA_TNUMBER = 3};
enum{LUA_TSTRING = 4};
enum{LUA_TTABLE = 5};
enum{LUA_TFUNCTION = 6};
enum{LUA_TUSERDATA = 7};
enum{LUA_TTHREAD = 8};
enum{LUA_MINSTACK = 20};
typedef LUA_NUMBER_ lua_Number;
typedef LUA_INTEGER_ lua_Integer;
Plua_State lua_newstate(luapas_lua_Alloc luapas_f,pointer ud);
void lua_close(Plua_State L);
Plua_State lua_newthread(Plua_State L);
luapas_lua_CFunction lua_atpanic(Plua_State L,luapas_lua_CFunction luapas_panicf);
LongInt lua_gettop(Plua_State L);
void lua_settop(Plua_State L,LongInt idx);
void lua_pushvalue(Plua_State L,LongInt idx);
void lua_remove(Plua_State L,LongInt idx);
void lua_insert(Plua_State L,LongInt idx);
void lua_replace(Plua_State L,LongInt idx);
LongBool lua_checkstack(Plua_State L,LongInt sz);
void lua_xmove(Plua_State src,Plua_State dest,LongInt n);
LongBool lua_isnumber(Plua_State L,LongInt idx);
LongBool lua_isstring(Plua_State L,LongInt idx);
LongBool lua_iscfunction(Plua_State L,LongInt idx);
LongBool lua_isuserdata(Plua_State L,LongInt idx);
LongInt lua_type(Plua_State L,LongInt idx);
PChar lua_typename(Plua_State L,LongInt tp);
LongBool lua_equal(Plua_State L,LongInt idx1,LongInt idx2);
LongBool lua_rawequal(Plua_State L,LongInt idx1,LongInt idx2);
LongBool lua_lessthan(Plua_State L,LongInt idx1,LongInt idx2);
lua_Number lua_tonumber(Plua_State L,LongInt idx);
lua_Integer lua_tointeger(Plua_State L,LongInt idx);
LongBool lua_toboolean(Plua_State L,LongInt idx);
PChar lua_tolstring(Plua_State L,LongInt idx,Psize_t len);
size_t lua_objlen(Plua_State L,LongInt idx);
luapas_lua_CFunction lua_tocfunction(Plua_State L,LongInt idx);
pointer lua_touserdata(Plua_State L,LongInt idx);
Plua_State lua_tothread(Plua_State L,LongInt idx);
pointer lua_topointer(Plua_State L,LongInt idx);
void lua_pushnil(Plua_State L);
void lua_pushnumber(Plua_State L,lua_Number n);
void lua_pushinteger(Plua_State L,lua_Integer n);
void lua_pushlstring(Plua_State L,PChar s,size_t ls);
void lua_pushstring(Plua_State L,PChar s);
PChar lua_pushvfstring(Plua_State L,PChar fmt,pointer argp);
PChar lua_pushfstring(Plua_State L,PChar fmt);
void lua_pushcclosure(Plua_State L,luapas_lua_CFunction luapas_fn,LongInt n);
void lua_pushboolean(Plua_State L,LongBool b);
void lua_pushlightuserdata(Plua_State L,pointer p);
Cardinal lua_pushthread(Plua_State L);
void lua_gettable(Plua_State L,LongInt idx);
void lua_getfield(Plua_State L,LongInt idx,PChar k);
void lua_rawget(Plua_State L,LongInt idx);
void lua_rawgeti(Plua_State L,LongInt idx,LongInt n);
void lua_createtable(Plua_State L,LongInt narr,LongInt nrec);
pointer lua_newuserdata(Plua_State L,size_t sz);
LongBool lua_getmetatable(Plua_State L,LongInt objindex);
void lua_getfenv(Plua_State L,LongInt idx);
void lua_settable(Plua_State L,LongInt idx);
void lua_setfield(Plua_State L,LongInt idx,PChar k);
void lua_rawset(Plua_State L,LongInt idx);
void lua_rawseti(Plua_State L,LongInt idx,LongInt n);
LongBool lua_setmetatable(Plua_State L,LongInt objindex);
LongBool lua_setfenv(Plua_State L,LongInt idx);
void lua_call(Plua_State L,LongInt nargs,LongInt nresults);
LongInt lua_pcall(Plua_State L,LongInt nargs,LongInt nresults,LongInt errfunc);
LongInt lua_cpcall(Plua_State L,luapas_lua_CFunction luapas_func,pointer ud);
LongInt lua_load(Plua_State L,luapas_lua_Reader luapas_reader,pointer dt,PChar chunkname);
LongInt lua_dump(Plua_State L,luapas_lua_Writer luapas_writer,pointer data);
LongInt lua_yield(Plua_State L,LongInt nresults);
LongInt lua_resume(Plua_State L,LongInt narg);
LongInt lua_status(Plua_State L);
enum{LUA_GCSTOP = 0};
enum{LUA_GCRESTART = 1};
enum{LUA_GCCOLLECT = 2};
enum{LUA_GCCOUNT = 3};
enum{LUA_GCCOUNTB = 4};
enum{LUA_GCSTEP = 5};
enum{LUA_GCSETPAUSE = 6};
enum{LUA_GCSETSTEPMUL = 7};
LongInt lua_gc(Plua_State L,LongInt what,LongInt data);
LongInt lua_error(Plua_State L);
LongInt lua_next(Plua_State L,LongInt idx);
void lua_concat(Plua_State L,LongInt n);
luapas_lua_Alloc lua_getallocf(Plua_State L,PPointer ud);
void lua_setallocf(Plua_State L,luapas_lua_Alloc luapas_f,pointer ud);
void luapas_lua_pop(Plua_State L,LongInt n);
void luapas_lua_newtable(Plua_State L);
void luapas_lua_register(Plua_State L,PChar n,luapas_lua_CFunction luapas_f);
void luapas_lua_pushcfunction(Plua_State L,luapas_lua_CFunction luapas_f);
LongInt luapas_lua_strlen(Plua_State L,LongInt idx);
boolean luapas_lua_isfunction(Plua_State L,LongInt n);
boolean luapas_lua_istable(Plua_State L,LongInt n);
boolean luapas_lua_islightuserdata(Plua_State L,LongInt n);
boolean luapas_lua_isnil(Plua_State L,LongInt n);
boolean luapas_lua_isboolean(Plua_State L,LongInt n);
boolean luapas_lua_isthread(Plua_State L,LongInt n);
boolean luapas_lua_isnone(Plua_State L,LongInt n);
boolean luapas_lua_isnoneornil(Plua_State L,LongInt n);
void luapas_lua_pushliteral(Plua_State L,PChar s);
void luapas_lua_setglobal(Plua_State L,PChar s);
void luapas_lua_getglobal(Plua_State L,PChar s);
string255 luapas_lua_tostring(Plua_State L,LongInt idx);
astring luapas_lua_tostringA(Plua_State L,LongInt idx);
Plua_State luapas_lua_open();
void luapas_lua_getregistry(Plua_State L);
LongInt luapas_lua_getgccount(Plua_State L);
typedef luapas_lua_Reader luapas_lua_Chuckreader;
typedef luapas_lua_Writer luapas_lua_Chuckwriter;
enum{LUA_HOOKCALL = 0};
enum{LUA_HOOKRET = 1};
enum{LUA_HOOKLINE = 2};
enum{LUA_HOOKCOUNT = 3};
enum{LUA_HOOKTAILRET = 4};
enum{LUA_MASKCALL = (1 << LUA_HOOKCALL)};
enum{LUA_MASKRET = (1 << LUA_HOOKRET)};
enum{LUA_MASKLINE = (1 << LUA_HOOKLINE)};
enum{LUA_MASKCOUNT = (1 << LUA_HOOKCOUNT)};
typedef struct __lua_Debug {
            LUA_INTEGER_ event;
            PChar name;
            PChar namewhat;
            PChar what;
            PChar source;
            LUA_INTEGER_ currentline;
            LUA_INTEGER_ nups;
            LUA_INTEGER_ linedefined;
            char short_src[(LUA_IDSIZE - 1) + 1];
            LUA_INTEGER_ i_ci;
        } lua_Debug;
typedef struct __lua_Debug * Plua_Debug;
typedef void(*luapas_lua_Hook)(Plua_State L,Plua_Debug ar);
LongInt lua_getstack(Plua_State L,LongInt level,Plua_Debug ar);
LongInt lua_getinfo(Plua_State L,PChar what,Plua_Debug ar);
PChar lua_getlocal(Plua_State L,Plua_Debug ar,LongInt n);
PChar lua_setlocal(Plua_State L,Plua_Debug ar,LongInt n);
PChar lua_getupvalue(Plua_State L,LongInt funcindex,LongInt n);
PChar lua_setupvalue(Plua_State L,LongInt funcindex,LongInt n);
LongInt lua_sethook(Plua_State L,luapas_lua_Hook luapas_func,LongInt mask,LongInt count);
LongInt lua_gethookmask(Plua_State L);
LongInt lua_gethookcount(Plua_State L);
static const string255 LUA_FILEHANDLE = STRINIT("FILE*");
static const string255 LUA_COLIBNAME = STRINIT("coroutine");
static const string255 LUA_TABLIBNAME = STRINIT("table");
static const string255 LUA_IOLIBNAME = STRINIT("io");
static const string255 LUA_OSLIBNAME = STRINIT("os");
static const string255 LUA_STRLIBNAME = STRINIT("string");
static const string255 LUA_MATHLIBNAME = STRINIT("math");
static const string255 LUA_DBLIBNAME = STRINIT("debug");
static const string255 LUA_LOADLIBNAME = STRINIT("package");
LongInt luaopen_base(Plua_State L);
LongInt luaopen_table(Plua_State L);
LongInt luaopen_io(Plua_State L);
LongInt luaopen_os(Plua_State L);
LongInt luaopen_string(Plua_State L);
LongInt luaopen_math(Plua_State L);
LongInt luaopen_debug(Plua_State L);
LongInt luaopen_package(Plua_State L);
void luaL_openlibs(Plua_State L);
void luapas_lua_assert(boolean x);
LongInt luapas_luaL_getn(Plua_State L,LongInt idx);
void luapas_luaL_setn(Plua_State L,LongInt i,LongInt j);
enum{LUA_ERRFILE = (LUA_ERRERR + 1)};
typedef struct __luaL_Reg {
            PChar name;
            luapas_lua_CFunction func;
        } luaL_Reg;
typedef struct __luaL_Reg * PluaL_Reg;
void luaL_openlib(Plua_State L,PChar libname,PluaL_Reg lr,LongInt nup);
void luaL_register(Plua_State L,PChar libname,PluaL_Reg lr);
LongInt luaL_getmetafield(Plua_State L,LongInt obj,PChar e);
LongInt luaL_callmeta(Plua_State L,LongInt obj,PChar e);
LongInt luaL_typerror(Plua_State L,LongInt narg,PChar tname);
LongInt luaL_argerror(Plua_State L,LongInt numarg,PChar extramsg);
PChar luaL_checklstring(Plua_State L,LongInt numArg,Psize_t ls);
PChar luaL_optlstring(Plua_State L,LongInt numArg,PChar def,Psize_t ls);
lua_Number luaL_checknumber(Plua_State L,LongInt numArg);
lua_Number luaL_optnumber(Plua_State L,LongInt nArg,lua_Number def);
lua_Integer luaL_checkinteger(Plua_State L,LongInt numArg);
lua_Integer luaL_optinteger(Plua_State L,LongInt nArg,lua_Integer def);
void luaL_checkstack(Plua_State L,LongInt sz,PChar msg);
void luaL_checktype(Plua_State L,LongInt narg,LongInt t);
void luaL_checkany(Plua_State L,LongInt narg);
LongInt luaL_newmetatable(Plua_State L,PChar tname);
pointer luaL_checkudata(Plua_State L,LongInt ud,PChar tname);
void luaL_where(Plua_State L,LongInt lvl);
LongInt luaL_error(Plua_State L,PChar fmt);
LongInt luaL_checkoption(Plua_State L,LongInt narg,PChar def,PChar * lst);
LongInt luaL_ref(Plua_State L,LongInt t);
void luaL_unref(Plua_State L,LongInt t,LongInt ref);
LongInt luaL_loadfile(Plua_State L,PChar filename);
LongInt luaL_loadbuffer(Plua_State L,PChar buff,size_t sz,PChar name);
LongInt luaL_loadstring(Plua_State L,PChar s);
Plua_State luaL_newstate();
PChar luaL_gsub(Plua_State L,PChar s,PChar p,PChar r);
PChar luaL_findtable(Plua_State L,LongInt idx,PChar fname,LongInt szhint);
LongInt luapas_luaL_argcheck(Plua_State L,boolean cond,LongInt numarg,PChar extramsg);
PChar luapas_luaL_checkstring(Plua_State L,LongInt n);
PChar luapas_luaL_optstring(Plua_State L,LongInt n,PChar d);
lua_Integer luapas_luaL_checkint(Plua_State L,LongInt n);
lua_Integer luapas_luaL_optint(Plua_State L,LongInt n,lua_Integer d);
lua_Integer luapas_luaL_checklong(Plua_State L,LongInt n);
lua_Integer luapas_luaL_optlong(Plua_State L,LongInt n,lua_Integer d);
PChar luapas_luaL_typename(Plua_State L,LongInt idx);
LongInt luapas_luaL_dofile(Plua_State L,PChar fn);
LongInt luapas_luaL_dostring(Plua_State L,PChar s);
void luapas_luaL_getmetatable(Plua_State L,PChar n);
typedef struct __luaL_Buffer {
            PChar p;
            LongInt lvl;
            Plua_State L;
            char buffer[(LUAL_BUFFERSIZE - 1) + 1];
        } luaL_Buffer;
typedef struct __luaL_Buffer * PluaL_Buffer;
void luapas_luaL_addchar(PluaL_Buffer B,char c);
void luapas_luaL_putchar(PluaL_Buffer B,char c);
void luapas_luaL_addsize(PluaL_Buffer B,LongInt n);
void luaL_buffinit(Plua_State L,PluaL_Buffer B);
PChar luaL_prepbuffer(PluaL_Buffer B);
void luaL_addlstring(PluaL_Buffer B,PChar s,size_t ls);
void luaL_addstring(PluaL_Buffer B,PChar s);
void luaL_addvalue(PluaL_Buffer B);
void luaL_pushresult(PluaL_Buffer B);
enum{LUA_NOREF = -2};
enum{LUA_REFNIL = -1};
LongInt luapas_lua_ref(Plua_State L,boolean lock);
void luapas_lua_unref(Plua_State L,LongInt ref);
void luapas_lua_getref(Plua_State L,LongInt ref);

