#include "fpcrtl.h"

#include "uLandGenMaze.h"
#include "uRandom.h"
#include "uLandOutline.h"
#include "uLandTemplates.h"
#include "uVariables.h"
#include "uFloat.h"
#include "uConsts.h"
#include "uLandGenTemplateBased.h"
#include "uUtils.h"
typedef struct __direction {
            LongInt x;
            LongInt y;
        } direction;
static direction DIR_N = {
                             .x = 0,
                             .y = -1
                         };
static direction DIR_E = {
                             .x = 1,
                             .y = 0
                         };
static direction DIR_S = {
                             .x = 0,
                             .y = 1
                         };
static direction DIR_W = {
                             .x = -1,
                             .y = 0
                         };
boolean ulandgenmaze_direction_direction_op_eq(direction a,direction b)
{
    boolean c_result;
    c_result = ((a.x) == (b.x)) && ((a.y) == (b.y));
    return c_result;
};
enum{small_cell_size = 128};
enum{medium_cell_size = 192};
enum{large_cell_size = 256};
enum{braidness = 10};
typedef struct __cell_t {
            LongInt x;
            LongInt y;
        } cell_t;
static LongInt x;
static LongInt y;
static LongInt cellsize;
static LongInt seen_cells_x;
static LongInt seen_cells_y;
static LongInt num_edges_x;
static LongInt num_edges_y;
static LongInt num_cells_x;
static LongInt num_cells_y;
typedef LongInt * (*seen_list_tt);
static fpcrtl_dimension_t seen_list_dimension_info ={.dim = 0, .a = {0, 0, 0, 0}};
static seen_list_tt seen_list = NULL;
typedef boolean * (*xwalls_tt);
static fpcrtl_dimension_t xwalls_dimension_info ={.dim = 0, .a = {0, 0, 0, 0}};
static xwalls_tt xwalls = NULL;
typedef boolean * (*ywalls_tt);
static fpcrtl_dimension_t ywalls_dimension_info ={.dim = 0, .a = {0, 0, 0, 0}};
static ywalls_tt ywalls = NULL;
typedef boolean * (*x_edge_list_tt);
static fpcrtl_dimension_t x_edge_list_dimension_info ={.dim = 0, .a = {0, 0, 0, 0}};
static x_edge_list_tt x_edge_list = NULL;
typedef boolean * (*y_edge_list_tt);
static fpcrtl_dimension_t y_edge_list_dimension_info ={.dim = 0, .a = {0, 0, 0, 0}};
static y_edge_list_tt y_edge_list = NULL;
typedef boolean * (*maze_tt);
static fpcrtl_dimension_t maze_dimension_info ={.dim = 0, .a = {0, 0, 0, 0}};
static maze_tt maze = NULL;
static TPixAr pa;
static LongInt num_vertices;
static LongInt off_y;
static LongInt num_steps;
static LongInt current_step;
typedef boolean * step_done_tt;
static fpcrtl_dimension_t step_done_dimension_info ={.dim = 0, .a = {0, 0, 0, 0}};
static step_done_tt step_done = NULL;
static boolean done;
typedef struct __cell_t * last_cell_tt;
static fpcrtl_dimension_t last_cell_dimension_info ={.dim = 0, .a = {0, 0, 0, 0}};
static last_cell_tt last_cell = NULL;
typedef struct __cell_t * (*came_from_tt);
static fpcrtl_dimension_t came_from_dimension_info ={.dim = 0, .a = {0, 0, 0, 0}};
static came_from_tt came_from = NULL;
typedef LongInt * came_from_pos_tt;
static fpcrtl_dimension_t came_from_pos_dimension_info ={.dim = 0, .a = {0, 0, 0, 0}};
static came_from_pos_tt came_from_pos = NULL;
static boolean maze_inverted;
LongInt ulandgenmaze_when_seen(LongInt x,LongInt y)
{
    LongInt when_seen_result;
    if(((((x) < (0)) || ((x) >= (seen_cells_x))) || ((y) < (0))) || ((y) >= (seen_cells_y)))
    {
        when_seen_result = current_step;
    }
    else
    {
        when_seen_result = seen_list[x][y];
    }
    return when_seen_result;
};
boolean ulandgenmaze_is_x_edge(LongInt x,LongInt y)
{
    boolean is_x_edge_result;
    if(((((x) < (0)) || ((x) > (num_edges_x))) || ((y) < (0))) || ((y) > (num_cells_y)))
    {
        is_x_edge_result = false;
    }
    else
    {
        is_x_edge_result = x_edge_list[x][y];
    }
    return is_x_edge_result;
};
boolean ulandgenmaze_is_y_edge(LongInt x,LongInt y)
{
    boolean is_y_edge_result;
    if(((((x) < (0)) || ((x) > (num_cells_x))) || ((y) < (0))) || ((y) > (num_edges_y)))
    {
        is_y_edge_result = false;
    }
    else
    {
        is_y_edge_result = y_edge_list[x][y];
    }
    return is_y_edge_result;
};
void ulandgenmaze_see_cell()
{
    direction dir;
    LongInt tries;
    LongInt x;
    LongInt y;
    boolean found_cell;
    boolean next_dir_clockwise;
    x = last_cell[current_step].x;
    y = last_cell[current_step].y;
    seen_list[x][y] = current_step;
    switch(urandom_GetRandom(4))
    {case 0:dir = DIR_N;
            break;
     case 1:dir = DIR_E;
            break;
     case 2:dir = DIR_S;
            break;
     case 3:dir = DIR_W;
            break;
     default: break;}
    tries = 0;
    found_cell = false;
    if((urandom_GetRandom(2)) == (1))
    {
        next_dir_clockwise = true;
    }
    else
    {
        next_dir_clockwise = false;
    }
    while(((tries) < (5)) && (!(found_cell)))
    {
        if((ulandgenmaze_when_seen((x) + (dir.x), (y) + (dir.y))) == (current_step))
        {
            if((!(maze_inverted)) && ((urandom_GetRandom(braidness)) == (0)))
            {
                switch(dir.x)
                {case -1:if((x) > (0))
                         {
                             ywalls[(x) - (1)][y] = false;
                         }
                         break;
                 case 1:if((x) < ((seen_cells_x) - (1)))
                        {
                            ywalls[x][y] = false;
                        }
                        break;
                 default: break;}
                switch(dir.y)
                {case -1:if((y) > (0))
                         {
                             xwalls[x][(y) - (1)] = false;
                         }
                         break;
                 case 1:if((y) < ((seen_cells_y) - (1)))
                        {
                            xwalls[x][y] = false;
                        }
                        break;
                 default: break;}
            }
            if(next_dir_clockwise)
            {
                if(ulandgenmaze_direction_direction_op_eq(dir, DIR_N))
                {
                    dir = DIR_E;
                }
                else
                {
                    if(ulandgenmaze_direction_direction_op_eq(dir, DIR_E))
                    {
                        dir = DIR_S;
                    }
                    else
                    {
                        if(ulandgenmaze_direction_direction_op_eq(dir, DIR_S))
                        {
                            dir = DIR_W;
                        }
                        else
                        {
                            dir = DIR_N;
                        }
                    }
                }
            }
            else
            {
                if(ulandgenmaze_direction_direction_op_eq(dir, DIR_N))
                {
                    dir = DIR_W;
                }
                else
                {
                    if(ulandgenmaze_direction_direction_op_eq(dir, DIR_E))
                    {
                        dir = DIR_N;
                    }
                    else
                    {
                        if(ulandgenmaze_direction_direction_op_eq(dir, DIR_S))
                        {
                            dir = DIR_E;
                        }
                        else
                        {
                            dir = DIR_S;
                        }
                    }
                }
            }
        }
        else
        {
            if((ulandgenmaze_when_seen((x) + (dir.x), (y) + (dir.y))) == (-1))
            {
                switch(dir.y)
                {case -1:xwalls[x][(y) - (1)] = false;
                         break;
                 case 1:xwalls[x][y] = false;
                        break;
                 default: break;}
                switch(dir.x)
                {case -1:ywalls[(x) - (1)][y] = false;
                         break;
                 case 1:ywalls[x][y] = false;
                        break;
                 default: break;}
                last_cell[current_step].x = (x) + (dir.x);
                last_cell[current_step].y = (y) + (dir.y);
                came_from_pos[current_step] = (came_from_pos[current_step]) + (1);
                came_from[current_step][came_from_pos[current_step]].x = x;
                came_from[current_step][came_from_pos[current_step]].y = y;
                found_cell = true;
            }
            else
            {
                step_done[current_step] = true;
                found_cell = true;
            }
        }
        tries = (tries) + (1);
    }
    if(!(found_cell))
    {
        last_cell[current_step].x = came_from[current_step][came_from_pos[current_step]].x;
        last_cell[current_step].y = came_from[current_step][came_from_pos[current_step]].y;
        came_from_pos[current_step] = (came_from_pos[current_step]) - (1);
        if((came_from_pos[current_step]) >= (0))
        {
            ulandgenmaze_see_cell();
        }
        else
        {
            step_done[current_step] = true;
        }
    }
};
void ulandgenmaze_add_vertex(LongInt x,LongInt y)
{
    LongInt tmp_x;
    LongInt tmp_y;
    LongInt nx;
    LongInt ny;
    if((x) == (NTPX))
    {
        if((pa.ar[(num_vertices) - (6)].x) == (NTPX))
        {
            num_vertices = (num_vertices) - (6);
        }
        else
        {
            pa.ar[num_vertices].x = NTPX;
            pa.ar[num_vertices].y = 0;
        }
    }
    else
    {
        if((maze_inverted) || (((x) % (2)) == (0)))
        {
            tmp_x = cellsize;
        }
        else
        {
            tmp_x = ((cellsize) * (2)) / (3);
        }
        if((maze_inverted) || (((y) % (2)) == (0)))
        {
            tmp_y = cellsize;
        }
        else
        {
            tmp_y = ((cellsize) * (2)) / (3);
        }
        nx = (((x) - (1)) * (cellsize)) + (tmp_x);
        ny = ((((y) - (1)) * (cellsize)) + (tmp_y)) + (off_y);
        if((num_vertices) > (2))
        {
            if((((pa.ar[(num_vertices) - (2)].x) == (pa.ar[(num_vertices) - (1)].x)) && ((pa.ar[(num_vertices) - (1)].x) == (nx))) || (((pa.ar[(num_vertices) - (2)].y) == (pa.ar[(num_vertices) - (1)].y)) && ((pa.ar[(num_vertices) - (1)].y) == (ny))))
            {
                --num_vertices;
            }
        }
        pa.ar[num_vertices].x = nx;
        pa.ar[num_vertices].y = ny;
    }
    num_vertices = (num_vertices) + (1);
};
void ulandgenmaze_add_edge(LongInt x,LongInt y,direction dir)
{
    LongInt i;
    if(ulandgenmaze_direction_direction_op_eq(dir, DIR_N))
    {
        dir = DIR_W;
    }
    else
    {
        if(ulandgenmaze_direction_direction_op_eq(dir, DIR_E))
        {
            dir = DIR_N;
        }
        else
        {
            if(ulandgenmaze_direction_direction_op_eq(dir, DIR_S))
            {
                dir = DIR_E;
            }
            else
            {
                dir = DIR_S;
            }
        }
    }
    {i = 0;
     LongInt i__end__ = 3;
     if (i <= i__end__) do {
                               if(ulandgenmaze_direction_direction_op_eq(dir, DIR_N))
                               {
                                   dir = DIR_E;
                               }
                               else
                               {
                                   if(ulandgenmaze_direction_direction_op_eq(dir, DIR_E))
                                   {
                                       dir = DIR_S;
                                   }
                                   else
                                   {
                                       if(ulandgenmaze_direction_direction_op_eq(dir, DIR_S))
                                       {
                                           dir = DIR_W;
                                       }
                                       else
                                       {
                                           dir = DIR_N;
                                       }
                                   }
                               }
                               if((ulandgenmaze_direction_direction_op_eq(dir, DIR_N)) && (ulandgenmaze_is_x_edge(x, y)))
                               {
                                   x_edge_list[x][y] = false;
                                   ulandgenmaze_add_vertex((x) + (1), y);
                                   ulandgenmaze_add_edge(x, (y) - (1), DIR_N);
                                   break;
                               }
                               if((ulandgenmaze_direction_direction_op_eq(dir, DIR_E)) && (ulandgenmaze_is_y_edge((x) + (1), y)))
                               {
                                   y_edge_list[(x) + (1)][y] = false;
                                   ulandgenmaze_add_vertex((x) + (2), (y) + (1));
                                   ulandgenmaze_add_edge((x) + (1), y, DIR_E);
                                   break;
                               }
                               if((ulandgenmaze_direction_direction_op_eq(dir, DIR_S)) && (ulandgenmaze_is_x_edge(x, (y) + (1))))
                               {
                                   x_edge_list[x][(y) + (1)] = false;
                                   ulandgenmaze_add_vertex((x) + (1), (y) + (2));
                                   ulandgenmaze_add_edge(x, (y) + (1), DIR_S);
                                   break;
                               }
                               if((ulandgenmaze_direction_direction_op_eq(dir, DIR_W)) && (ulandgenmaze_is_y_edge(x, y)))
                               {
                                   y_edge_list[x][y] = false;
                                   ulandgenmaze_add_vertex(x, (y) + (1));
                                   ulandgenmaze_add_edge((x) - (1), y, DIR_W);
                                   break;
                               }
                           } while(i++ != i__end__);}
};
void ulandgenmaze_GenMaze()
{
    LongWord i;
    switch(cTemplateFilter)
    {case 0:{
                cellsize = small_cell_size;
                maze_inverted = false;
                minDistance = uutils_Max((cFeatureSize) * (8), 32);
                dabDiv = 150;
            }
            break;
     case 1:{
                cellsize = medium_cell_size;
                minDistance = uutils_Max((cFeatureSize) * (6), 20);
                maze_inverted = false;
                dabDiv = 100;
            }
            break;
     case 2:{
                cellsize = large_cell_size;
                minDistance = uutils_Max((cFeatureSize) * (5), 12);
                maze_inverted = false;
                dabDiv = 90;
            }
            break;
     case 3:{
                cellsize = small_cell_size;
                minDistance = uutils_Max((cFeatureSize) * (8), 32);
                maze_inverted = true;
                dabDiv = 130;
            }
            break;
     case 4:{
                cellsize = medium_cell_size;
                minDistance = uutils_Max((cFeatureSize) * (6), 20);
                maze_inverted = true;
                dabDiv = 100;
            }
            break;
     case 5:{
                cellsize = large_cell_size;
                minDistance = uutils_Max((cFeatureSize) * (5), 12);
                maze_inverted = true;
                dabDiv = 85;
            }
            break;
     default: break;}
    num_cells_x = (LAND_WIDTH) / (cellsize);
    if(!(fpcrtl_odd(num_cells_x)))
    {
        num_cells_x = (num_cells_x) - (1);
    }
    num_cells_y = (LAND_HEIGHT) / (cellsize);
    if(!(fpcrtl_odd(num_cells_y)))
    {
        num_cells_y = (num_cells_y) - (1);
    }
    num_edges_x = (num_cells_x) - (1);
    num_edges_y = (num_cells_y) - (1);
    seen_cells_x = (num_cells_x) / (2);
    seen_cells_y = (num_cells_y) / (2);
    if(maze_inverted)
    {
        num_steps = 3;
    }
    else
    {
        num_steps = 1;
    }
    fpcrtl_SetLength(step_done, num_steps);
    fpcrtl_SetLength(last_cell, num_steps);
    fpcrtl_SetLength(came_from_pos, num_steps);
    fpcrtl_SetLength(came_from, num_steps, (num_cells_x) * (num_cells_y));
    done = false;
    {current_step = 0;
     LongInt current_step__end__ = (num_steps) - (1);
     if (current_step <= current_step__end__) do {
                                                     step_done[current_step] = false;
                                                     came_from_pos[current_step] = 0;
                                                 } while(current_step++ != current_step__end__);}
    current_step = 0;
    fpcrtl_SetLength(seen_list, seen_cells_x, seen_cells_y);
    fpcrtl_SetLength(xwalls, seen_cells_x, (seen_cells_y) - (1));
    fpcrtl_SetLength(ywalls, (seen_cells_x) - (1), seen_cells_y);
    fpcrtl_SetLength(x_edge_list, num_edges_x, num_cells_y);
    fpcrtl_SetLength(y_edge_list, num_cells_x, num_edges_y);
    fpcrtl_SetLength(maze, num_cells_x, num_cells_y);
    num_vertices = 0;
    playHeight = (num_cells_y) * (cellsize);
    playWidth = (num_cells_x) * (cellsize);
    off_y = (LAND_HEIGHT) - (playHeight);
    {x = 0;
     LongInt x__end__ = playWidth;
     if (x <= x__end__) do {
                               {y = 0;
                                LongInt y__end__ = (off_y) - (1);
                                if (y <= y__end__) do {
                                                          Land[y][x] = 0;
                                                      } while(y++ != y__end__);}
                           } while(x++ != x__end__);}
    {x = 0;
     LongInt x__end__ = playWidth;
     if (x <= x__end__) do {
                               {y = off_y;
                                LongInt y__end__ = (LAND_HEIGHT) - (1);
                                if (y <= y__end__) do {
                                                          Land[y][x] = lfBasic;
                                                      } while(y++ != y__end__);}
                           } while(x++ != x__end__);}
    {y = 0;
     LongInt y__end__ = (num_cells_y) - (1);
     if (y <= y__end__) do {
                               {x = 0;
                                LongInt x__end__ = (num_cells_x) - (1);
                                if (x <= x__end__) do {
                                                          maze[x][y] = false;
                                                      } while(x++ != x__end__);}
                           } while(y++ != y__end__);}
    {x = 0;
     LongInt x__end__ = (seen_cells_x) - (1);
     if (x <= x__end__) do {
                               {y = 0;
                                LongInt y__end__ = (seen_cells_y) - (2);
                                if (y <= y__end__) do {
                                                          xwalls[x][y] = true;
                                                      } while(y++ != y__end__);}
                           } while(x++ != x__end__);}
    {x = 0;
     LongInt x__end__ = (seen_cells_x) - (2);
     if (x <= x__end__) do {
                               {y = 0;
                                LongInt y__end__ = (seen_cells_y) - (1);
                                if (y <= y__end__) do {
                                                          ywalls[x][y] = true;
                                                      } while(y++ != y__end__);}
                           } while(x++ != x__end__);}
    {x = 0;
     LongInt x__end__ = (seen_cells_x) - (1);
     if (x <= x__end__) do {
                               {y = 0;
                                LongInt y__end__ = (seen_cells_y) - (1);
                                if (y <= y__end__) do {
                                                          seen_list[x][y] = -(1);
                                                      } while(y++ != y__end__);}
                           } while(x++ != x__end__);}
    {x = 0;
     LongInt x__end__ = (num_edges_x) - (1);
     if (x <= x__end__) do {
                               {y = 0;
                                LongInt y__end__ = (num_cells_y) - (1);
                                if (y <= y__end__) do {
                                                          x_edge_list[x][y] = false;
                                                      } while(y++ != y__end__);}
                           } while(x++ != x__end__);}
    {x = 0;
     LongInt x__end__ = (num_cells_x) - (1);
     if (x <= x__end__) do {
                               {y = 0;
                                LongInt y__end__ = (num_edges_y) - (1);
                                if (y <= y__end__) do {
                                                          y_edge_list[x][y] = false;
                                                      } while(y++ != y__end__);}
                           } while(x++ != x__end__);}
    {current_step = 0;
     LongInt current_step__end__ = (num_steps) - (1);
     if (current_step <= current_step__end__) do {
                                                     x = (urandom_GetRandom((seen_cells_x) - (1))) / (((LongWord)num_steps));
                                                     last_cell[current_step].x = (x) + (((current_step) * (seen_cells_x)) / (num_steps));
                                                     last_cell[current_step].y = urandom_GetRandom(seen_cells_y);
                                                 } while(current_step++ != current_step__end__);}
    while(!(done))
    {
        done = true;
        {current_step = 0;
         LongInt current_step__end__ = (num_steps) - (1);
         if (current_step <= current_step__end__) do {
                                                         if(!(step_done[current_step]))
                                                         {
                                                             ulandgenmaze_see_cell();
                                                             done = false;
                                                         }
                                                     } while(current_step++ != current_step__end__);}
    }
    {x = 0;
     LongInt x__end__ = (seen_cells_x) - (1);
     if (x <= x__end__) do {
                               {y = 0;
                                LongInt y__end__ = (seen_cells_y) - (1);
                                if (y <= y__end__) do {
                                                          if((seen_list[x][y]) > (-1))
                                                          {
                                                              maze[(((x) + (1)) * (2)) - (1)][(((y) + (1)) * (2)) - (1)] = true;
                                                          }
                                                      } while(y++ != y__end__);}
                           } while(x++ != x__end__);}
    {x = 0;
     LongInt x__end__ = (seen_cells_x) - (1);
     if (x <= x__end__) do {
                               {y = 0;
                                LongInt y__end__ = (seen_cells_y) - (2);
                                if (y <= y__end__) do {
                                                          if(!(xwalls[x][y]))
                                                          {
                                                              maze[((x) * (2)) + (1)][((y) * (2)) + (2)] = true;
                                                          }
                                                      } while(y++ != y__end__);}
                           } while(x++ != x__end__);}
    {x = 0;
     LongInt x__end__ = (seen_cells_x) - (2);
     if (x <= x__end__) do {
                               {y = 0;
                                LongInt y__end__ = (seen_cells_y) - (1);
                                if (y <= y__end__) do {
                                                          if(!(ywalls[x][y]))
                                                          {
                                                              maze[((x) * (2)) + (2)][((y) * (2)) + (1)] = true;
                                                          }
                                                      } while(y++ != y__end__);}
                           } while(x++ != x__end__);}
    {x = 0;
     LongInt x__end__ = (num_edges_x) - (1);
     if (x <= x__end__) do {
                               {y = 0;
                                LongInt y__end__ = (num_cells_y) - (1);
                                if (y <= y__end__) do {
                                                          if((maze[x][y]) ^ (maze[(x) + (1)][y]))
                                                          {
                                                              x_edge_list[x][y] = true;
                                                          }
                                                          else
                                                          {
                                                              x_edge_list[x][y] = false;
                                                          }
                                                      } while(y++ != y__end__);}
                           } while(x++ != x__end__);}
    {x = 0;
     LongInt x__end__ = (num_cells_x) - (1);
     if (x <= x__end__) do {
                               {y = 0;
                                LongInt y__end__ = (num_edges_y) - (1);
                                if (y <= y__end__) do {
                                                          if((maze[x][y]) ^ (maze[x][(y) + (1)]))
                                                          {
                                                              y_edge_list[x][y] = true;
                                                          }
                                                          else
                                                          {
                                                              y_edge_list[x][y] = false;
                                                          }
                                                      } while(y++ != y__end__);}
                           } while(x++ != x__end__);}
    {x = 0;
     LongInt x__end__ = (num_edges_x) - (1);
     if (x <= x__end__) do {
                               {y = 0;
                                LongInt y__end__ = (num_cells_y) - (1);
                                if (y <= y__end__) do {
                                                          if(x_edge_list[x][y])
                                                          {
                                                              x_edge_list[x][y] = false;
                                                              ulandgenmaze_add_vertex((x) + (1), (y) + (1));
                                                              ulandgenmaze_add_vertex((x) + (1), y);
                                                              ulandgenmaze_add_edge(x, (y) - (1), DIR_N);
                                                              ulandgenmaze_add_vertex(NTPX, 0);
                                                          }
                                                      } while(y++ != y__end__);}
                           } while(x++ != x__end__);}
    pa.Count = num_vertices;
    leftX = 0;
    rightX = playWidth;
    topY = off_y;
    pa.ar[pa.Count].x = 1;
    pa.ar[pa.Count].y = (1) + (off_y);
    do {
           i = pa.Count;
           ulandgentemplatebased_DivideEdges(1, &(pa));
       } while(!((i) == (pa.Count)));
    ulandoutline_BezierizeEdge(&(pa), _0_2);
    ulandoutline_DrawEdge(&(pa), 0);
    if(maze_inverted)
    {
        ulandoutline_FillLand(1, (1) + (off_y), 0, 0);
    }
    else
    {
        x = 0;
        while((Land[(((cellsize) / (2)) + (cellsize)) + (off_y)][x]) == (lfBasic))
        {
            x = (x) + (1);
        }
        while((Land[(((cellsize) / (2)) + (cellsize)) + (off_y)][x]) == (0))
        {
            x = (x) + (1);
        }
        ulandoutline_FillLand((x) + (1), (((cellsize) / (2)) + (cellsize)) + (off_y), 0, 0);
    }
    MaxHedgehogs = 32;
    if(((GameFlags) & (gfDisableGirders)) != (0))
    {
        hasGirders = false;
    }
    else
    {
        hasGirders = true;
    }
    hasBorder = false;
};
