#include "fpcrtl.h"

#include "uLandOutline.h"
#include "uLandGraphics.h"
#include "uDebug.h"
#include "uVariables.h"
#include "uLandTemplates.h"
static const string255 __str0 = STRINIT("FillLand: stack overflow");
typedef struct __Stack_tt {
            LongWord Count;
            struct __points {
                LongInt xl;
                LongInt xr;
                LongInt y;
                LongInt dir;
            } points[8192 + 1];
        } Stack_tt;
static Stack_tt Stack;
void ulandoutline_Push(LongInt _xl,LongInt _xr,LongInt _y,LongInt _dir)
{
    if(udebug_checkFails((Stack.Count) <= (8192), __str0, true))
    {
        return;
    }
    _y = (_y) + (_dir);
    if(((_y) < (0)) || ((_y) >= (LAND_HEIGHT)))
    {
        return;
    }
    {
        Stack.points[Stack.Count].xl = _xl;
        Stack.points[Stack.Count].xr = _xr;
        Stack.points[Stack.Count].y = _y;
        Stack.points[Stack.Count].dir = _dir;
    }
    ++Stack.Count;
};
void ulandoutline_Pop(LongInt (*_xl),LongInt (*_xr),LongInt (*_y),LongInt (*_dir))
{
    --Stack.Count;
    {
        (*_xl) = Stack.points[Stack.Count].xl;
        (*_xr) = Stack.points[Stack.Count].xr;
        (*_y) = Stack.points[Stack.Count].y;
        (*_dir) = Stack.points[Stack.Count].dir;
    }
};
void ulandoutline_FillLand(LongInt x,LongInt y,Word border,Word value)
{
    LongInt xl;
    LongInt xr;
    LongInt dir;
    Stack.Count = 0;
    xl = (x) - (1);
    xr = x;
    ulandoutline_Push(xl, xr, y, -(1));
    ulandoutline_Push(xl, xr, y, 1);
    dir = 0;
    while((Stack.Count) > (0))
    {
        ulandoutline_Pop(&(xl), &(xr), &(y), &(dir));
        while((((xl) > (0)) && ((Land[y][xl]) != (border))) && ((Land[y][xl]) != (value)))
        {
            --xl;
        }
        while((((xr) < ((LAND_WIDTH) - (1))) && ((Land[y][xr]) != (border))) && ((Land[y][xr]) != (value)))
        {
            ++xr;
        }
        while((xl) < (xr))
        {
            while(((xl) <= (xr)) && (((Land[y][xl]) == (border)) || ((Land[y][xl]) == (value))))
            {
                ++xl;
            }
            x = xl;
            while((((xl) <= (xr)) && ((Land[y][xl]) != (border))) && ((Land[y][xl]) != (value)))
            {
                Land[y][xl] = value;
                ++xl;
            }
            if((x) < (xl))
            {
                ulandoutline_Push(x, (int)(xl) - 1, y, dir);
                ulandoutline_Push(x, (int)(xl) - 1, y, -(dir));
            }
        }
    }
};
void ulandoutline_DrawEdge(TPixAr (*pa),Word value)
{
    LongInt i;
    i = 0;
    {
        while((i) < ((((LongInt)(*pa).Count)) - (1)))
        {
            if(((*pa).ar[(i) + (1)].x) == (NTPX))
            {
                i += 2;
            }
            else
            {
                ulandgraphics_DrawLine((*pa).ar[i].x, (*pa).ar[i].y, (*pa).ar[(i) + (1)].x, (*pa).ar[(i) + (1)].y, value);
                ++i;
            }
        }
    }
};
void ulandoutline_Vector(TPoint p1,TPoint p2,TPoint p3,hwFloat (*Vx),hwFloat (*Vy))
{
    hwFloat d1;
    hwFloat d2;
    hwFloat d;
    (*Vx) = ufloat_int2hwFloat((p1.x) - (p3.x));
    (*Vy) = ufloat_int2hwFloat((p1.y) - (p3.y));
    d2 = ufloat_Distance((*Vx), (*Vy));
    if((d2.QWordValue) == (0))
    {
        (*Vx) = _0;
        (*Vy) = _0;
    }
    else
    {
        d = ufloat_DistanceI((p2.x) - (p1.x), (p2.y) - (p1.y));
        d1 = ufloat_DistanceI((p2.x) - (p3.x), (p2.y) - (p3.y));
        if(ufloat_hwFloat_hwFloat_op_lt(d1, d))
        {
            d = d1;
        }
        if(ufloat_hwFloat_hwFloat_op_lt(d2, d))
        {
            d = d2;
        }
        d2 = ufloat_hwFloat_hwFloat_op_div(ufloat_hwFloat_hwFloat_op_mul(d, _1div3), d2);
        (*Vx) = ufloat_hwFloat_hwFloat_op_mul((*Vx), d2);
        (*Vy) = ufloat_hwFloat_hwFloat_op_mul((*Vy), d2);
    }
};
void ulandoutline_AddLoopPoints(TPixAr (*pa),TPixAr (*opa),LongInt StartI,LongInt EndI,hwFloat Delta)
{
    LongInt i;
    LongInt pi;
    LongInt ni;
    hwFloat NVx;
    hwFloat NVy;
    hwFloat PVx;
    hwFloat PVy;
    LongInt x1;
    LongInt x2;
    LongInt y1;
    LongInt y2;
    hwFloat tsq;
    hwFloat tcb;
    hwFloat t;
    hwFloat r1;
    hwFloat r2;
    hwFloat r3;
    hwFloat cx1;
    hwFloat cx2;
    hwFloat cy1;
    hwFloat cy2;
    LongInt X;
    LongInt Y;
    if(((*pa).Count) < ((cMaxEdgePoints) - (2)))
    {
        pi = EndI;
        i = StartI;
        ni = StartI + 1;
        ulandoutline_Vector((*opa).ar[pi], (*opa).ar[i], (*opa).ar[ni], &(NVx), &(NVy));
        do {
               i = ni;
               ++pi;
               if((pi) > (EndI))
               {
                   pi = StartI;
               }
               ++ni;
               if((ni) > (EndI))
               {
                   ni = StartI;
               }
               PVx = NVx;
               PVy = NVy;
               ulandoutline_Vector((*opa).ar[pi], (*opa).ar[i], (*opa).ar[ni], &(NVx), &(NVy));
               x1 = (*opa).ar[pi].x;
               y1 = (*opa).ar[pi].y;
               x2 = (*opa).ar[i].x;
               y2 = (*opa).ar[i].y;
               cx1 = ufloat_hwFloat_hwFloat_op_sub(ufloat_int2hwFloat(x1), PVx);
               cy1 = ufloat_hwFloat_hwFloat_op_sub(ufloat_int2hwFloat(y1), PVy);
               cx2 = ufloat_hwFloat_hwFloat_op_add(ufloat_int2hwFloat(x2), NVx);
               cy2 = ufloat_hwFloat_hwFloat_op_add(ufloat_int2hwFloat(y2), NVy);
               t = _0;
               while(((t.Round) == (0)) && (((*pa).Count) < ((cMaxEdgePoints) - (2))))
               {
                   tsq = ufloat_hwFloat_hwFloat_op_mul(t, t);
                   tcb = ufloat_hwFloat_hwFloat_op_mul(tsq, t);
                   r1 = ufloat_hwFloat_hwFloat_op_sub(ufloat_hwFloat_hwFloat_op_add(ufloat_hwFloat_hwFloat_op_sub(_1, ufloat_hwFloat_LongInt_op_mul(t, 3)), ufloat_hwFloat_LongInt_op_mul(tsq, 3)), tcb);
                   r2 = ufloat_hwFloat_hwFloat_op_add(ufloat_hwFloat_hwFloat_op_sub(ufloat_hwFloat_LongInt_op_mul(t, 3), ufloat_hwFloat_LongInt_op_mul(tsq, 6)), ufloat_hwFloat_LongInt_op_mul(tcb, 3));
                   r3 = ufloat_hwFloat_hwFloat_op_sub(ufloat_hwFloat_LongInt_op_mul(tsq, 3), ufloat_hwFloat_LongInt_op_mul(tcb, 3));
                   X = ufloat_hwRound(ufloat_hwFloat_hwFloat_op_add(ufloat_hwFloat_hwFloat_op_add(ufloat_hwFloat_hwFloat_op_add(ufloat_hwFloat_LongInt_op_mul(r1, x1), ufloat_hwFloat_hwFloat_op_mul(r2, cx1)), ufloat_hwFloat_hwFloat_op_mul(r3, cx2)), ufloat_hwFloat_LongInt_op_mul(tcb, x2)));
                   Y = ufloat_hwRound(ufloat_hwFloat_hwFloat_op_add(ufloat_hwFloat_hwFloat_op_add(ufloat_hwFloat_hwFloat_op_add(ufloat_hwFloat_LongInt_op_mul(r1, y1), ufloat_hwFloat_hwFloat_op_mul(r2, cy1)), ufloat_hwFloat_hwFloat_op_mul(r3, cy2)), ufloat_hwFloat_LongInt_op_mul(tcb, y2)));
                   t = ufloat_hwFloat_hwFloat_op_add(t, Delta);
                   (*pa).ar[(*pa).Count].x = X;
                   (*pa).ar[(*pa).Count].y = Y;
                   ++(*pa).Count;
               }
           } while(!((i) == (StartI)));
    }
    (*pa).ar[(*pa).Count].x = (*opa).ar[StartI].x;
    (*pa).ar[(*pa).Count].y = (*opa).ar[StartI].y;
    ++(*pa).Count;
};
void ulandoutline_BezierizeEdge(TPixAr (*pa),hwFloat Delta)
{
    LongInt i;
    LongInt StartLoop;
    TPixAr opa;
    opa = (*pa);
    (*pa).Count = 0;
    i = 0;
    StartLoop = 0;
    while(((i) < (((LongInt)opa.Count))) && (((*pa).Count) < ((cMaxEdgePoints) - (1))))
    {
        if((opa.ar[(i) + (1)].x) == (NTPX))
        {
            ulandoutline_AddLoopPoints(&((*pa)), &(opa), StartLoop, i, Delta);
            i += 2;
            StartLoop = i;
            (*pa).ar[(*pa).Count].x = NTPX;
            (*pa).ar[(*pa).Count].y = 0;
            ++(*pa).Count;
        }
        else
        {
            ++i;
        }
    }
};
